<template>
  <v-stepper class="elevation-0" v-model="currentStep">
    <v-stepper-header>
      <v-stepper-step
        :complete="currentStep > 1"
        step="1"
        color="#9652DF"
        :class="mobile ? 'px-1 py-3' : ''"
      >
        Datos Básicos
      </v-stepper-step>

      <v-divider />

      <v-stepper-step
        :complete="currentStep > 2"
        step="2"
        color="#9652DF"
        :class="mobile ? 'px-1 py-3' : ''"
      >
        Otros Datos
      </v-stepper-step>

      <v-divider />

      <v-stepper-step
        step="3"
        color="#9652DF"
        :class="mobile ? 'px-1 py-3' : ''"
      >
        Confirmación
      </v-stepper-step>
    </v-stepper-header>

    <v-form
      ref="specialistRegistrationForm"
      v-model="specialistRegistrationFormValid"
    >
      <v-stepper-items class="tway-stepper">
        <!-- PASO 1 -->
        <v-stepper-content step="1">
          <div class="stepper-item mb-5" v-if="newCompany">
            <label>Razón Social de tu empresa</label>
            <v-text-field
              v-model="company.name"
              class="roboto"
              placeholder="Escribe aquí la Razón Social"
            />
          </div>
          <div class="stepper-item mb-5">
            <v-row>
              <v-col>
                <label
                  >En relación a la Transformación Digital,<br />¿En cuál de
                  estas dimensiones impacta tu empresa?</label
                >
              </v-col>
            </v-row>
            <v-select
              v-model="company.dimensions"
              :items="dimensions"
              item-text="name"
              attach
              chips
              label="Selecciona una o varias dimensiones"
              multiple
              class="roboto condensed"
            >
              <template v-slot:selection="{ item, index }">
                <v-chip v-if="index === 0 || index === 1 || index === 2">
                  <span v-if="item.name"
                    >{{ item.name.substring(0, 13) }}
                    <span v-if="item.name.length > 13">..</span></span
                  >
                </v-chip>
                <span v-if="index === 3" class="grey--text caption">
                  (+{{ company.dimensions.length - 3 }})
                </span>
              </template>
            </v-select>
            <span v-if="mobile" class="select-subtitle roboto"
              >{{ company.dimensions.length }} dimensiones seleccionadas</span
            >
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-2">
            <v-row>
              <v-col>
                <label
                  >¿Qué servicios o productos ofreces para la Transformación
                  Digital?</label
                >
              </v-col>
            </v-row>

            <choice
              :data="categories"
              :data-selections="company.services"
              @array="company.services = $event"
              ref="choice"
              class="roboto"
            />
            <span v-if="mobile" class="select-subtitle roboto"
              >{{ company.services.length }} servicios seleccionados</span
            >
            <v-checkbox
              v-model="checkboxServices"
              color="success"
              :label="'No encontré el servicio que ofrezco.'"
            />
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-2">
            <v-row>
              <v-col>
                <label>Sectores en los cuales has prestado servicios</label>
              </v-col>
            </v-row>
            <v-select
              v-model="company.industrialSectors"
              :items="availableIndustrialSectors"
              item-text="name"
              attach
              chips
              label="Sectores"
              multiple
              class="roboto"
            >
              <template v-slot:selection="{ item, index }">
                <v-chip v-if="index === 0 || index === 1 || index === 2">
                  <span v-if="item.name"
                    >{{ item.name.substring(0, 13) }}
                    <span v-if="item.name.length > 13">..</span></span
                  >
                </v-chip>
                <span v-if="index === 3" class="grey--text caption">
                  (+{{ company.industrialSectors.length - 3 }})
                </span>
              </template>
            </v-select>
            <span v-if="mobile" class="select-subtitle roboto"
              >{{ company.industrialSectors.length }} sectores</span
            >
            <v-checkbox
              v-if="!sectorSet"
              v-model="checkboxSectors"
              color="success"
              :label="'No he prestado servicios en estos sectores.'"
            />
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-5">
            <label>Año de inicio de actividades</label>
            <v-tooltip bottom class="tooltip">
              <template v-slot:activator="{ on }">
                <v-icon small v-on="on" class="ml-auto icono">
                  mdi-information-outline
                </v-icon>
              </template>
              <span v-if="!newCompany" class="sii roboto"
                >Dato entregado por el SII</span
              >
              <span v-if="newCompany" class="sii roboto"
                >Ingresa el año donde tu empresa comenzó actividades en el
                SII</span
              >
            </v-tooltip>
            <v-text-field
              v-model="company.trajectory"
              :disabled="yearSet"
              :rules="[validYear()]"
              maxlength="4"
              class="roboto"
            />
          </div>

          <v-row class="pa-0 ma-0 mb-5" justify="center" align="center">
            <div class="d-inline roboto mr-2">
              <v-btn
                class="
                  text-lowercase text-decoration-underline text-body-1
                  roboto
                  lower
                "
                rounded
                text
                x-small
                color="deep-purple accent-4"
                @click="goBack"
              >
                <capital>completar más tarde</capital>
              </v-btn>
            </div>
            <div class="d-inline">
              <v-btn
                depressed
                rounded
                class="button-text tway-violet white--text roboto elevation-3"
                @click="updateProfile(2)"
              >
                Siguiente
              </v-btn>
            </div>
          </v-row>
        </v-stepper-content>
        <!-- PASO 2 -->
        <v-stepper-content step="2">
          <div class="stepper-item mb-5">
            <label>Cuéntanos acerca de tu empresa</label>
            <v-textarea
              v-model="company.contributionValue"
              rows="3"
              no-resize
              placeholder="Breve descripción sobre tu producto o servicio que ofreces"
              hide-details
              class="roboto"
            />
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-5">
            <label>Tamaño</label>
            <v-tooltip bottom class="tooltip">
              <template v-slot:activator="{ on }">
                <v-icon small v-on="on" class="ml-auto icono">
                  mdi-information-outline
                </v-icon>
              </template>
              <span v-if="!newCompany" class="sii roboto"
                >Dato entregado por el SII</span
              >
              <span v-if="newCompany" class="sii roboto"
                >El tamaño está definido según el rango de facturación de tu
                empresa.</span
              >
            </v-tooltip>
            <v-select
              v-if="newCompany"
              class="subtitle-2 roboto"
              v-model="company.size"
              :items="availableSizes"
              :item-text="
                (availableSizes) =>
                  `${availableSizes.name} ${availableSizes.salesUfRange}`
              "
              placeholder="Selecciona un tamaño acorde a tu empresa"
              return-object
            />
            <v-select
              v-else
              class="subtitle-2 roboto"
              v-model="company.size"
              :disabled="sizeSet"
              :items="availableSizes"
              :item-text="textRange"
              persistent-hint
              hint="(No compartiremos tu información de facturación)"
              placeholder="Selecciona un tamaño acorde a tu empresa"
              return-object
            />
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-5" v-if="newCompany">
            <label>Cantidad de trabajadores</label>
            <v-text-field
              v-model="company.workers"
              class="roboto"
              :rules="[ValidWorkers()]"
              placeholder="Ingresa la cantidad total de trabajadores"
            />
          </div>
          <div class="stepper-item mb-5">
            <label>Sitio Web</label>
            <v-text-field
              class="subtitle-2 roboto"
              v-model="company.web"
              placeholder="Ingresa el sitio web de tu empresa"
            />
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-5">
            <label>Perfil Linkedin</label>
            <v-text-field
              class="subtitle-2 roboto"
              v-model="company.linkedIn"
              placeholder="Ingresa el link del perfil de LinkedIn de tu empresa"
            />
          </div>
          <v-row class="pa-0 ma-0 mb-5" justify="center" align="center">
            <v-col
              class="pa-0 ma-0"
              cols="3"
              xs="3"
              sm="3"
              md="2"
              lg="2"
              xl="2"
            >
              <v-btn
                outlined
                color="deep-purple accent-4"
                class="button-text"
                rounded
                @click="currentStep = 1"
              >
                Atrás
              </v-btn>
            </v-col>
            <v-col
              class="pa-0 ma-0"
              cols="3"
              xs="3"
              sm="3"
              md="2"
              lg="2"
              xl="2"
            >
              <v-btn
                depressed
                rounded
                class="button-text tway-violet white--text"
                @click="updateProfile(3)"
              >
                Siguiente
              </v-btn>
            </v-col>
          </v-row>
          <v-row class="pa-0 ma-0 mb-5" justify="center" align="center">
            <div :class="mobile ? 'text-center' : 'text-left'">
              <v-btn
                class="
                  text-lowercase text-decoration-underline text-body-1
                  roboto
                  mt-2
                  lower
                "
                text
                small
                color="tway-purple"
                @click="goBack"
              >
                <capital>completar más tarde</capital>
              </v-btn>
            </div>
          </v-row>
        </v-stepper-content>
        <!-- PASO 3 -->
        <v-stepper-content step="3">
          <v-row v-if="company.name && newCompany" class="stepper-item mb-3">
            <v-col>
              <div class="h6">Razón Social</div>
              <div>
                <a class="subtitle-2 roboto" style="color: #999999">{{
                  company.name
                }}</a>
              </div>
            </v-col>
          </v-row>
          <div v-if="company.name && newCompany" class="separator mb-6" />
          <div class="stepper-item mb-5">
            <div class="h6">Impacto en Transformación Digital</div>
            <v-row>
              <v-col cols="10">
                <div>
                  <v-tooltip
                    class="d-inline mr-2"
                    v-for="(sector, index) in flag0
                      ? company.dimensions
                      : company.dimensions.slice(0, 3)"
                    :key="index"
                    bottom
                  >
                    <template v-slot:activator="{ on }">
                      <v-chip v-on="on" color="tway-gray mb-2">
                        <span class="roboto">{{ sector }}</span>
                      </v-chip>
                    </template>
                    <span>{{ sector }}</span>
                  </v-tooltip>
                </div>
              </v-col>
              <v-col cols="2">
                <v-btn
                  id="expand_button"
                  @click="
                    () => {
                      flag0 = !flag0;
                    }
                  "
                  value="expand"
                  icon
                  color="tway-violet"
                >
                  <v-icon v-if="flag0"> expand_less </v-icon>
                  <v-icon v-if="!flag0"> expand_more </v-icon>
                </v-btn>
              </v-col>
            </v-row>
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-5">
            <div class="h6">Productos y Servicios</div>
            <v-row>
              <v-col cols="10">
                <div>
                  <v-tooltip
                    class="d-inline mr-2"
                    v-for="(service, index) in flag1
                      ? company.services
                      : company.services.slice(0, 3)"
                    :key="index"
                    bottom
                  >
                    <template v-slot:activator="{ on }">
                      <v-chip v-on="on" color="tway-gray mb-2">
                        <span class="roboto">{{ service.name }}</span>
                      </v-chip>
                    </template>
                    <span>{{ service.name }}</span>
                  </v-tooltip>
                </div>
              </v-col>
              <v-col cols="2">
                <v-btn
                  id="expand_button"
                  @click="
                    () => {
                      flag1 = !flag1;
                    }
                  "
                  value="expand"
                  icon
                  color="tway-violet"
                >
                  <v-icon v-if="flag1"> expand_less </v-icon>
                  <v-icon v-if="!flag1"> expand_more </v-icon>
                </v-btn>
              </v-col>
            </v-row>
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-5">
            <div class="h6">Experiencia en</div>
            <v-row>
              <v-col cols="10">
                <div>
                  <v-tooltip
                    class="d-inline mr-2"
                    v-for="(sector, index) in flag2
                      ? company.industrialSectors
                      : company.industrialSectors.slice(0, 3)"
                    :key="index"
                    bottom
                  >
                    <template v-slot:activator="{ on }">
                      <v-chip v-on="on" color="tway-gray mb-2">
                        <span class="roboto">{{ sector }}</span>
                      </v-chip>
                    </template>
                    <span>{{ sector }}</span>
                  </v-tooltip>
                </div>
              </v-col>
              <v-col cols="2">
                <v-btn
                  id="expand_button2"
                  @click="
                    () => {
                      flag2 = !flag2;
                    }
                  "
                  value="expand"
                  icon
                  color="tway-violet"
                >
                  <v-icon v-if="flag2"> expand_less </v-icon>
                  <v-icon v-if="!flag2"> expand_more </v-icon>
                </v-btn>
              </v-col>
            </v-row>
          </div>
          <div v-if="company.contributionValue" class="separator mb-6" />
          <div v-if="company.contributionValue" class="stepper-item mb-5">
            <div class="h6">Acerca de la Empresa</div>
            <div class="subtitle-2 roboto" style="color: #999999">
              {{ company.contributionValue }}
            </div>
          </div>
          <div v-if="company.trajectory" class="separator mb-6" />
          <v-row v-if="company.trajectory" class="stepper-item mb-3">
            <v-col>
              <div class="h6">Inicio Actividades</div>
              <div>
                <a class="subtitle-2 roboto" style="color: #999999">{{
                  company.trajectory
                }}</a>
              </div>
            </v-col>
          </v-row>

          <div v-if="company.size" class="separator mb-6" />
          <v-row v-if="company.size" class="stepper-item mb-3">
            <v-col>
              <div class="h6">Tamaño</div>
              <div>
                <a
                  class="subtitle-2 roboto"
                  style="color: #999999"
                  v-if="company.size"
                  >{{ company.size.name }} {{ company.size.salesUfRange }}</a
                >
              </div>
            </v-col>
          </v-row>
          <div v-if="company.workers" class="separator mb-6" />
          <v-row v-if="company.workers" class="stepper-item mb-3">
            <v-col>
              <div class="h6">Cantidad de Trabajadores</div>
              <div>
                <a class="subtitle-2 roboto" style="color: #999999">{{
                  company.workers
                }}</a>
              </div>
            </v-col>
          </v-row>
          <div v-if="company.web" class="separator mb-6" />
          <v-row v-if="company.web" class="stepper-item mb-3">
            <v-col>
              <div>
                <div class="h6">Sitio Web</div>
                <div>
                  <a
                    target="_blank"
                    class="subtitle-2 roboto"
                    style="color: #999999"
                    v-if="company.web !== ''"
                    :href="'http://' + company.web"
                    >{{ company.web }}</a
                  >
                </div>
              </div>
            </v-col>
          </v-row>
          <div v-if="company.linkedIn" class="separator mb-6" />
          <v-row v-if="company.linkedIn" class="stepper-item mb-3">
            <v-col>
              <div>
                <div class="h6">Perfil Linkedin</div>
                <div>
                  <a
                    class="subtitle-2 roboto"
                    style="color: #999999"
                    target="_blank"
                    v-if="company.linkedIn !== ''"
                    :href="'http://' + company.linkedIn"
                    >{{ company.linkedIn }}</a
                  >
                </div>
              </div>
            </v-col>
          </v-row>

          <v-row
            :class="mobile ? '' : 'ml-9'"
            class="pa-0 ma-0 mb-5"
            justify="center"
          >
            <v-col
              class="pa-0 ma-0"
              cols="3"
              xs="2"
              sm="2"
              md="2"
              lg="2"
              xl="2"
            >
              <v-btn
                outlined
                color="deep-purple accent-4"
                class="button-text"
                rounded
                @click="currentStep = 2"
              >
                Atrás
              </v-btn>
            </v-col>
            <v-col
              class="pa-0 ma-0"
              cols="6"
              xs="6"
              sm="6"
              md="4"
              lg="4"
              xl="4"
            >
              <v-btn
                depressed
                rounded
                class="button-text tway-violet white--text"
                :to="{ name: 'my-profile' }"
              >
                Confirmar mi perfil
              </v-btn>
            </v-col>
          </v-row>
          <v-row class="pa-0 ma-0 mb-5" justify="center" align="center">
            <div :class="mobile ? 'text-center' : 'text-left'">
              <v-btn
                class="
                  text-lowercase text-decoration-underline text-body-1
                  roboto
                  mt-2
                  lower
                "
                text
                small
                color="tway-purple"
                @click="goBack"
              >
                <capital>completar más tarde</capital>
              </v-btn>
            </div>
          </v-row>
        </v-stepper-content>
      </v-stepper-items>
    </v-form>
  </v-stepper>
</template>

<style lang="scss" scoped>
.stepper-btn-group *:not(:last-child) {
  margin-right: 10px;
}
.scroll {
  overflow: auto;
  white-space: nowrap;
}
.extended {
  position: relative;
  display: block;
  overflow: hidden;
}
.separator {
  border: 1px solid #f1f1f1;
  width: 100%;
}
.select-subtitle {
  font-size: 16px;
  line-height: 24px;
  color: #cccccc;
}
capital {
  text-transform: lowercase;
}

capital::first-letter {
  text-transform: uppercase;
}

.icono {
  width: 38px;
  color: #4a148c;
  top: -2px;
  font-size: 18px !important;
}

.sii {
  color: white;
}
.tooltip {
  color: #4a148c;
}
</style>
<script>
import companyService from "@/services/companyService";
import Choice from "@/components/elements/Choice.vue";

export default {
  name: "SpecialistRegistration",

  components: {
    choice: Choice,
  },

  props: {
    companyData: {
      type: Object,
      required: true,
    },
  },

  data() {
    return {
      specialistRegistrationFormValid: false,
      company: {
        name: "",
        about: "",
        services: [],
        dimensions: [],
        industrialSectors: [],
        trayectory: "",
        size: {
          name: "",
        },
        web: "",
        linkedIn: "",
      },
      currentStep: 1,
      availableServices: [],
      availableIndustrialSectors: [],
      availableSizes: [],
      button: false,
      flag0: false,
      flag1: false,
      flag2: false,
      categories: [],
      dimensions: [],
      yearSet: false,
      sizeSet: false,
      sectorSet: false,
      newCompany: false,
      checkboxServices: false,
      checkboxSectors: false,
    };
  },

  created() {
    this.company = this._.assign(this.company, this.companyData);
    if (this.company.trajectory && this.company.checked) {
      this.yearSet = true;
    }
    if (this.company.size && this.company.checked) {
      this.sizeSet = true;
    }
    if (this.company.industrialSectors && this.company.checked) {
      this.sectorSet = true;
    }
    if (this.company.dimensions) {
      this.company.dimensions = this.company.dimensions.map((e) => {
        return e.name;
      });
    }
    if (!this.company.checked) {
      this.newCompany = true;
    } else {
      this.newCompany = false;
    }

    let userInfo = JSON.parse(localStorage.getItem("userInfo"));
    let clientId = "";
    if (userInfo && userInfo.principal && userInfo.principal.clientId) {
      clientId = userInfo.principal.clientId;
    }

    if (clientId) {
      companyService
        .getCategories(clientId)
        .then((response) => {
          this.categories = response;
        })
        .catch((err) => this.$log.error(err));
      companyService
        .getDimensions(clientId)
        .then((response) => {
          this.dimensions = response;
        })
        .catch((err) => this.$log.error(err));
      companyService
        .getSectors(clientId)
        .then((response) => {
          this.availableIndustrialSectors = response;
        })
        .catch((err) => this.$log.error(err));
      companyService
        .getSizes(clientId)
        .then((response) => {
          this.availableSizes = response;
        })
        .catch((err) => this.$log.error(err));
    }
  },

  methods: {
    updateProfile(step) {
      if (this.$refs.specialistRegistrationForm.validate()) {
        let data = this.company;

        companyService
          .updateCompanyProfile(data)
          .then(() => (this.currentStep = step))
          .catch((err) => this.$log.error(err));
      }
    },

    validYear() {
      const pattern = new RegExp("^\\d{4}$");
      const currentYear = new Date().getFullYear();
      return (v) => {
        if (v) {
          return (
            (pattern.test(v) && parseInt(v) <= currentYear && v > 1000) ||
            "Debes ingresar un año válido"
          );
        }

        return true;
      };
    },

    ValidWorkers() {
      return (v) => {
        if (v) {
          return v > 0 || "Debes ingresar la cantidad de trabajadores";
        }
        return true;
      };
    },

    goBack() {
      this.$router.go(-1);
    },
    textRange() {
      return this.company.size.name + " " + this.company.size.salesUfRange;
    },
  },

  watch: {
    currentStep() {
      if (this.currentStep > 1) {
        this.$emit("hide", true);
      } else {
        this.$emit("hide", false);
      }
    },
    checkboxSectors() {
      if (this.checkboxSectors) {
        this.company.industrialSectors = [];
      }
    },
    checkboxServices() {
      if (this.checkboxServices) {
        this.$refs.choice.clean();
        this.company.services = [];
      }
    },
    "company.industrialSectors"() {
      if (this.company.industrialSectors.length > 0) {
        this.checkboxSectors = false;
      }
    },
    "company.services"() {
      if (this.company.services.length > 0) {
        this.checkboxServices = false;
      }
    },
  },
  computed: {
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },
};
</script>
